import random
import numpy as np
import tensorflow as tf
from mpi4py import MPI

def set_seed(i, env, envE):
  rank = MPI.COMM_WORLD.Get_rank()
  myseed = i  + 10000 * rank if i is not None else None
  random.seed(myseed)
  np.random.seed(myseed)
  tf.random.set_seed(myseed)
  env.seed(myseed)
  envE.seed(myseed)
